Index: pcp/src/wannier.c
===================================================================
--- pcp/src/wannier.c	(revision 9bdd866eca950981175d4eb672952e1c119b1d98)
+++ pcp/src/wannier.c	(revision 4f136930622a3ef24a8e10066443133f1c24c77c)
@@ -213,4 +216,887 @@
     MPI_Wait(&requestR1, &status);
   //fprintf(stderr,"...done\n");
+}
+
+/** By testing of greatest common divisor of the matrix rows (\a AllocNum) finds suitable parallel cpu group.
+ * \param *P Problem at hand
+ * \param AllocNum number of rows in matrix
+ * \return address of MPI communicator
+ */
+#ifdef HAVE_INLINE
+inline MPI_Comm * DetermineParallelGroupbyGCD (struct Problem *P, int AllocNum)
+#else
+MPI_Comm * DetermineParallelGroupbyGCD (struct Problem *P, int AllocNum)
+#endif
+{
+  MPI_Comm *comm = &P->Par.comm_ST;
+  
+  //if (P->Call.out[ReadOut]) fprintf(stderr,"(%i) Comparing groups - AllocNum %i --- All %i\t Psi %i\t PsiT %i\n",P->Par.me, AllocNum, P->Par.Max_me_comm_ST, P->Par.Max_me_comm_ST_Psi, P->Par.Max_my_color_comm_ST_Psi);
+  //if (P->Call.out[ReadOut]) fprintf(stderr,"(%i) Jacobi diagonalization is done parallely by ", P->Par.me);
+  if (AllocNum % (P->Par.Max_me_comm_ST*2) == 0) {  // all parallel
+    comm = &P->Par.comm_ST;
+    //if (P->Call.out[ReadOut]) fprintf(stderr,"all\n");           
+  } else if (P->Par.Max_me_comm_ST_Psi >= P->Par.Max_my_color_comm_ST_Psi) { // always the bigger group comes first  
+    if (AllocNum % (P->Par.Max_me_comm_ST_Psi*2) == 0) {  // coefficients parallel
+      comm = &P->Par.comm_ST_Psi;
+      //if (P->Call.out[ReadOut]) fprintf(stderr,"Psi\n");       
+    } else if (AllocNum % (P->Par.Max_my_color_comm_ST_Psi*2) == 0) {  // Psis parallel
+      comm = &P->Par.comm_ST_PsiT;
+      //if (P->Call.out[ReadOut]) fprintf(stderr,"PsiT\n");       
+    }
+  } else {
+    if (AllocNum % (P->Par.Max_my_color_comm_ST_Psi*2) == 0) {  // Psis parallel 
+      comm = &P->Par.comm_ST_PsiT;
+      //if (P->Call.out[ReadOut]) fprintf(stderr,"PsiT\n");       
+    } else if (AllocNum % (P->Par.Max_me_comm_ST_Psi*2) == 0) {  // coefficients parallel
+      comm = &P->Par.comm_ST_Psi;
+      //if (P->Call.out[ReadOut]) fprintf(stderr,"Psi\n");       
+    }
+  }
+  return comm;
+}
+
+/** Allocates and fills Lookup table for sin/cos values at each grid node.
+ * \param ***cos_table pointer to two-dimensional lookup table for cosine values
+ * \param ***sin_table pointer to two-dimensional lookup table for sine values
+ * \param *N array with number of nodes per \a NDIM axis
+ */
+void CreateSinCosLookupTable(double ***cos_table, double ***sin_table, int *N)
+{
+  int i, j;
+  double argument;
+  double **cos_lookup, **sin_lookup;
+  
+  // create lookup table for sin/cos values
+  cos_lookup = (double **) Malloc(sizeof(double *)*NDIM, "ComputeMLWF: *cos_lookup");
+  sin_lookup = (double **) Malloc(sizeof(double *)*NDIM, "ComputeMLWF: *sin_lookup");  
+  for (i=0;i<NDIM;i++) {
+    // allocate memory
+    cos_lookup[i] = (double *) Malloc(sizeof(double)*N[i], "ComputeMLWF: cos_lookup");
+    sin_lookup[i] = (double *) Malloc(sizeof(double)*N[i], "ComputeMLWF: sin_lookup");
+    
+    // reset arrays
+    SetArrayToDouble0(cos_lookup[i],N[i]);
+    SetArrayToDouble0(sin_lookup[i],N[i]);
+    
+    // create lookup values
+    for (j=0;j<N[i];j++) {
+      argument = 2*PI/(double)N[i]*(double)j; 
+      cos_lookup[i][j] = cos(argument);
+      sin_lookup[i][j] = sin(argument);
+    }
+  }
+  *cos_table = cos_lookup;
+  *sin_table = sin_lookup;
+}
+
+/** Frees memory allocated during CreateSinCosLookupTable().
+ * \param ***cos_lookup pointer to two-dimensional lookup table for cosine values
+ * \param ***sin_lookup pointer to two-dimensional lookup table for sine values
+ */
+void FreeSinCosLookupTable(double **cos_lookup, double **sin_lookup)
+{
+  int i;
+  // free lookups
+  for (i=0;i<NDIM;i++) {
+    Free(cos_lookup[i], "FreeSinCosLookupTable: cos_lookup[i]");
+    Free(sin_lookup[i], "FreeSinCosLookupTable: sin_lookup[i]");
+  }
+  Free(cos_lookup, "FreeSinCosLookupTable: cos_lookup");
+  Free(sin_lookup, "FreeSinCosLookupTable: sin_lookup");
+}
+
+/** Fills the entries of the six variance matrices.
+ * These matrices are parallely diagonalized during Wannier Localization. They are calculated from the
+ * wave function and by diagonalization one obtains the unitary transformation with which the Psis are
+ * treated afterwards.
+ * \param *P Problem at hand
+ * \param AllocNum number of rows/columns
+ * \param **A pointer to variance matrices
+ * \sa ComputeMLWF() - master function. 
+ */
+void FillHigherOrderRealMomentsMatrices(struct Problem *P, int AllocNum, gsl_matrix **A)
+{
+  struct Lattice *Lat = &P->Lat;
+  struct RunStruct *R = &P->R;
+  struct Psis *Psi = &Lat->Psi;
+  struct LatticeLevel *Lev0 = R->Lev0;
+  struct LatticeLevel *LevS = R->LevS;
+  struct Density *Dens0 = Lev0->Dens;
+  struct OnePsiElement *OnePsiA, *OnePsiB, *LOnePsiB;
+  struct fft_plan_3d *plan = Lat->plan; 
+  fftw_complex *PsiC = Dens0->DensityCArray[ActualPsiDensity];
+  fftw_real *PsiCR = (fftw_real *)PsiC;
+  fftw_complex *work = Dens0->DensityCArray[Temp2Density]; 
+  fftw_real **HGcR = &Dens0->DensityArray[HGDensity];  // use HGDensity, 4x Gap..Density, TempDensity as a storage array
+  fftw_complex **HGcRC = (fftw_complex**)HGcR;
+  fftw_complex **HGcR2C = &Dens0->DensityCArray[HGcDensity];  // use HGcDensity, 4x Gap..Density, TempDensity as an array
+  fftw_real **HGcR2 = (fftw_real**)HGcR2C;
+  int ElementSize = (sizeof(fftw_complex) / sizeof(double)), RecvSource;
+  MPI_Status status;
+  fftw_complex *LPsiDatA=NULL, *LPsiDatB=NULL;
+  int n[NDIM],n0,i0,iS, Index;
+  int Num = Psi->NoOfPsis;  // is number of occupied plus unoccupied states for rows
+  int N0 = LevS->Plan0.plan->local_nx;
+  int *N = LevS->Plan0.plan->N;
+  const int NUpx = LevS->NUp[0];
+  const int NUpy = LevS->NUp[1];
+  const int NUpz = LevS->NUp[2];
+  double argument, PsiAtNode;
+  int e,g,i,j,k,l,m,p,u;
+  double a_ij = 0, b_ij = 0, A_ij = 0, B_ij = 0;
+  double **cos_lookup =  NULL,**sin_lookup = NULL; 
+
+  if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 2\n",P->Par.me);
+
+  debug(P, "Creating Lookup Table");
+  CreateSinCosLookupTable(&cos_lookup, &sin_lookup, N);
+
+  debug(P, "Calculating each entry of variance matrices");
+  l=-1; // to access U matrix element (0..Num-1)
+  // fill the matrices
+  for (i=0; i < Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT; i++) {  // go through all wave functions
+    OnePsiA = &Psi->AllPsiStatus[i];    // grab OnePsiA
+    if (OnePsiA->PsiType == type) {   // drop all but occupied ones
+      l++;  // increase l if it is non-extra wave function
+      if (OnePsiA->my_color_comm_ST_Psi == P->Par.my_color_comm_ST_Psi) // local?
+        LPsiDatA=LevS->LPsi->LocalPsi[OnePsiA->MyLocalNo];
+      else
+        LPsiDatA = NULL;  // otherwise processes won't enter second loop, though they're supposed to send coefficients!
+      
+      //fprintf(stderr,"(%i),(%i,%i): fft'd, A[..] and B, back-fft'd acting on \\phi_A\n",P->Par.me,l,0);
+      if (LPsiDatA != NULL) {
+        CalculateOneDensityR(Lat, LevS, Dens0, LPsiDatA, Dens0->DensityArray[ActualDensity], R->FactorDensityR, 1);
+        // note: factor is not used when storing result in DensityCArray[ActualPsiDensity] in CalculateOneDensityR()!
+        for (n0=0;n0<N0;n0++)  
+          for (n[1]=0;n[1]<N[1];n[1]++) 
+            for (n[2]=0;n[2]<N[2];n[2]++) {
+              i0 = n[2]*NUpz+N[2]*NUpz*(n[1]*NUpy+N[1]*NUpy*n0*NUpx);
+              iS = n[2]+N[2]*(n[1]+N[1]*n0);
+              n[0] = n0 + LevS->Plan0.plan->start_nx;
+              for (k=0;k<max_operators;k+=2) {
+                e = k/2;
+                argument = 2.*PI/(double)(N[e])*(double)(n[e]);
+                PsiAtNode = PsiCR[i0] /LevS->MaxN;
+                // check lookup
+                if (!l) // perform check on first wave function only
+                  if ((fabs(cos(argument) - cos_lookup[e][n[e]]) > MYEPSILON) || (fabs(sin(argument) - sin_lookup[e][n[e]]) > MYEPSILON)) {
+                    Error(SomeError, "Lookup table does not match real value!");
+                  }
+                HGcR[k][iS] = cos_lookup[e][n[e]] * PsiAtNode; /* Matrix Vector Mult */
+                HGcR2[k][iS] = cos_lookup[e][n[e]] * HGcR[k][iS]; /* Matrix Vector Mult */
+                HGcR[k+1][iS] = sin_lookup[e][n[e]] * PsiAtNode; /* Matrix Vector Mult */
+                HGcR2[k+1][iS] = sin_lookup[e][n[e]] * HGcR[k+1][iS]; /* Matrix Vector Mult */
+              }
+            }
+        for (u=0;u<max_operators;u++) {
+          fft_3d_real_to_complex(plan, LevS->LevelNo, FFTNF1, HGcRC[u], work);
+          fft_3d_real_to_complex(plan, LevS->LevelNo, FFTNF1, HGcR2C[u], work);
+        }
+      }  
+      m = -1; // to access U matrix element (0..Num-1)
+      for (j=0; j < Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT; j++) {  // go through all wave functions
+        OnePsiB = &Psi->AllPsiStatus[j];    // grab OnePsiB
+        if (OnePsiB->PsiType == type) {   // drop all but occupied ones
+          m++;  // increase m if it is non-extra wave function
+          if (OnePsiB->my_color_comm_ST_Psi == P->Par.my_color_comm_ST_Psi) // local?
+             LOnePsiB = &Psi->LocalPsiStatus[OnePsiB->MyLocalNo];
+          else 
+             LOnePsiB = NULL;
+          if (LOnePsiB == NULL) {   // if it's not local ... receive it from respective process into TempPsi
+            RecvSource = OnePsiB->my_color_comm_ST_Psi;
+            MPI_Recv( LevS->LPsi->TempPsi, LevS->MaxG*ElementSize, MPI_DOUBLE, RecvSource, WannierTag2, P->Par.comm_ST_PsiT, &status );
+            LPsiDatB=LevS->LPsi->TempPsi;
+          } else {                  // .. otherwise send it to all other processes (Max_me... - 1)
+            for (p=0;p<P->Par.Max_me_comm_ST_PsiT;p++)
+              if (p != OnePsiB->my_color_comm_ST_Psi) 
+                MPI_Send( LevS->LPsi->LocalPsi[OnePsiB->MyLocalNo], LevS->MaxG*ElementSize, MPI_DOUBLE, p, WannierTag2, P->Par.comm_ST_PsiT);
+            LPsiDatB=LevS->LPsi->LocalPsi[OnePsiB->MyLocalNo];
+          } // LPsiDatB is now set to the coefficients of OnePsi either stored or MPI_Received
+
+          for (u=0;u<max_operators;u++) {
+            a_ij = 0;
+            b_ij = 0;
+            if (LPsiDatA != NULL) { // calculate, reduce and send to all ...
+              //fprintf(stderr,"(%i),(%i,%i): A[%i]: multiplying with \\phi_B\n",P->Par.me, l,m,u);
+              g=0;
+              if (LevS->GArray[0].GSq == 0.0) {
+                Index = LevS->GArray[g].Index;
+                a_ij = (LPsiDatB[0].re*HGcRC[u][Index].re + LPsiDatB[0].im*HGcRC[u][Index].im);
+                b_ij = (LPsiDatB[0].re*HGcR2C[u][Index].re + LPsiDatB[0].im*HGcR2C[u][Index].im);
+                g++;
+              }
+              for (; g < LevS->MaxG; g++) {
+                Index = LevS->GArray[g].Index;
+                a_ij += 2*(LPsiDatB[g].re*HGcRC[u][Index].re + LPsiDatB[g].im*HGcRC[u][Index].im);
+                b_ij += 2*(LPsiDatB[g].re*HGcR2C[u][Index].re + LPsiDatB[g].im*HGcR2C[u][Index].im);
+              } // due to the symmetry the resulting matrix element is real and symmetric in (i,j) ! (complex multiplication simplifies ...)
+              // sum up elements from all coefficients sharing processes
+              MPI_Allreduce ( &a_ij, &A_ij, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_Psi);
+              MPI_Allreduce ( &b_ij, &B_ij, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_Psi);
+              a_ij = A_ij;
+              b_ij = B_ij;
+              // send element to all Psi-sharing who don't have l local (MPI_Send is a lot slower than AllReduce!)
+              MPI_Allreduce ( &a_ij, &A_ij, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_PsiT);
+              MPI_Allreduce ( &b_ij, &B_ij, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_PsiT);
+            } else { // receive ...
+              MPI_Allreduce ( &a_ij, &A_ij, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_PsiT);
+              MPI_Allreduce ( &b_ij, &B_ij, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_PsiT);              
+            }
+            // ... and store
+            //fprintf(stderr,"(%i),(%i,%i): A[%i]: setting component (local: %lg, total: %lg)\n",P->Par.me, l,m,u,a_ij,A_ij);
+            //fprintf(stderr,"(%i),(%i,%i): B: adding upon component (local: %lg, total: %lg)\n",P->Par.me, l,m,b_ij,B_ij);
+            gsl_matrix_set(A[u], l, m, A_ij);
+            gsl_matrix_set(A[max_operators], l, m, B_ij + gsl_matrix_get(A[max_operators],l,m));
+          }
+        }
+      }
+    }
+  }
+  // reset extra entries
+  for (u=0;u<=max_operators;u++) {
+    for (i=Num;i<AllocNum;i++)
+      for (j=0;j<AllocNum;j++)
+        gsl_matrix_set(A[u], i,j, 0.);
+    for (i=Num;i<AllocNum;i++)
+      for (j=0;j<AllocNum;j++)
+        gsl_matrix_set(A[u], j,i, 0.);
+  }
+  FreeSinCosLookupTable(cos_lookup, sin_lookup);
+
+/*// print A matrices for debug
+  if (P->Par.me == 0) 
+    for (u=0;u<max_operators+1;u++) {
+     fprintf(stderr, "A[%i] = \n",u);
+      for (i=0;i<Num;i++) {
+        for (j=0;j<Num;j++)
+          fprintf(stderr, "%e\t",gsl_matrix_get(A[u],i,j));
+        fprintf(stderr, "\n");
+      }
+    }  
+*/
+}
+
+/** Calculates reciprocal second order moments of each PsiType#Occupied orbital.
+ * First order is zero due to wave function being real (symmetry condition).
+ * \param *P Problem at hand
+ */
+void CalculateSecondOrderReciprocalMoment(struct Problem *P)
+{
+  struct Lattice *Lat = &P->Lat;
+  struct RunStruct *R = &P->R;
+  struct FileData *F = &P->Files;
+  struct Psis *Psi = &Lat->Psi;
+  struct LatticeLevel *LevS = R->LevS;
+  double result, Result; 
+  fftw_complex *LPsiDatA=NULL;
+  struct OnePsiElement *OnePsiA;
+  int i,j,l,g;
+  char spin[12], suffix[18];
+
+  switch (Lat->Psi.PsiST) {
+  case SpinDouble:
+    strcpy(suffix,".recispread.csv");    
+    strcpy(spin,"SpinDouble");
+    break;
+  case SpinUp:
+    strcpy(suffix,".recispread_up.csv");    
+    strcpy(spin,"SpinUp");
+    break;
+  case SpinDown:
+    strcpy(suffix,".recispread_down.csv");    
+    strcpy(spin,"SpinDown");
+    break;
+  }
+  if(P->Par.me_comm_ST == 0) {
+    if (P->Call.out[NormalOut]) fprintf(stderr,"(%i) Calculating reciprocal moments ...\n",P->Par.me);
+    if (R->LevSNo == Lat->MaxLevel-1) // open freshly if first level 
+      OpenFile(P, &F->ReciSpreadFile, suffix, "w", P->Call.out[ReadOut]); // only open on starting level
+    else if (F->ReciSpreadFile == NULL) // re-op,18en if not first level and not opened yet (or closed from ParseWannierFile)
+      OpenFile(P, &F->ReciSpreadFile, suffix, "a", P->Call.out[ReadOut]); // only open on starting level
+    if (F->ReciSpreadFile == NULL) {
+      Error(SomeError,"ComputeMLWF: Error opening Reciprocal spread File!\n");
+    } else {   
+      fprintf(F->ReciSpreadFile,"===== Reciprocal Spreads of type %s ==========================================================================\n", spin);
+    }
+  }
+
+  // integrate second order moment
+  for (l=0; l < Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT; l++) {  // go through all wave functions
+    OnePsiA = &Psi->AllPsiStatus[l];    // grab OnePsiA
+    if (OnePsiA->PsiType == type) {   // drop all but occupied ones
+      if (OnePsiA->my_color_comm_ST_Psi == P->Par.my_color_comm_ST_Psi) // local?
+        LPsiDatA=LevS->LPsi->LocalPsi[OnePsiA->MyLocalNo];
+      else
+        LPsiDatA = NULL;
+      
+      if (LPsiDatA != NULL) {
+        if (P->Par.me_comm_ST == 0) 
+          fprintf(F->ReciSpreadFile,"Psi%d_Lev%d\t", Psi->AllPsiStatus[l].MyGlobalNo, R->LevSNo); 
+        for (i=0;i<NDIM;i++) {
+          for (j=0;j<NDIM;j++) {
+            result = 0.;
+            g = 0;
+            if (LevS->GArray[0].GSq == 0.0) {
+              result += LevS->GArray[g].G[i]*LevS->GArray[g].G[j]*(LPsiDatA[0].re * LPsiDatA[0].re);
+              g++;
+            }
+            for (;g<LevS->MaxG;g++)
+              result += LevS->GArray[g].G[i]*LevS->GArray[g].G[j]*2.*(LPsiDatA[g].re * LPsiDatA[g].re + LPsiDatA[g].im * LPsiDatA[g].im);
+            //result *= Lat->Volume/LevS->MaxG;
+            MPI_Allreduce ( &result, &Result, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_Psi);
+            if (P->Par.me_comm_ST == 0) 
+              fprintf(F->ReciSpreadFile,"%2.5lg  ", Result);
+          }
+        }
+        if (P->Par.me_comm_ST == 0) 
+          fprintf(F->ReciSpreadFile,"\n");
+      }
+    }
+  }
+  if(P->Par.me_comm_ST == 0) { 
+    fprintf(F->ReciSpreadFile,"====================================================================================================================\n\n");
+    fflush(F->ReciSpreadFile);
+  }
+}
+
+/** Given the unitary matrix the transformation is performed on the Psis.
+ * \param *P Problem at hand
+ * \param *U gsl matrix containing the transformation matrix
+ * \param Num dimension parameter for the matrix, i.e. number of wave functions
+ */
+void UnitaryTransformationOnWavefunctions(struct Problem *P, gsl_matrix *U, int Num)
+{
+  struct Lattice *Lat = &P->Lat;
+  struct RunStruct *R = &P->R;
+  struct Psis *Psi = &Lat->Psi;
+  struct LatticeLevel *LevS = R->LevS;
+  MPI_Status status;
+  struct OnePsiElement *OnePsiB, *OnePsiA, *LOnePsiB;
+  int ElementSize = (sizeof(fftw_complex) / sizeof(double)), RecvSource;
+  fftw_complex *LPsiDatA=NULL, *LPsiDatB=NULL;
+  int g,i,j,l,k,m,p;
+
+  //if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 6: Transformation of all wave functions according to U\n",P->Par.me); 
+  
+  Num = Psi->TypeStartIndex[type+1] - Psi->TypeStartIndex[type]; // recalc Num as we can only work with local Psis from here
+  fftw_complex **coeffs_buffer = Malloc(sizeof(fftw_complex *)*Num, "ComputeMLWF: **coeffs_buffer");
+
+  for (l=0;l<Num;l++) // allocate for each local wave function
+    coeffs_buffer[l] = LevS->LPsi->OldLocalPsi[l];
+  
+  //if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 6: Transformation ...\n",P->Par.me);
+  l=-1; // to access U matrix element (0..Num-1)
+  k=-1; // to access the above swap coeffs_buffer (0..LocalNo-1)
+  for (i=0; i < Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT; i++) {  // go through all wave functions
+    OnePsiA = &Psi->AllPsiStatus[i];    // grab OnePsiA
+    if (OnePsiA->PsiType == type) {   // drop all but occupied ones
+      l++;  // increase l if it is occupied wave function
+      if (OnePsiA->my_color_comm_ST_Psi == P->Par.my_color_comm_ST_Psi) { // local?
+        k++; // increase k only if it is a local, non-extra orbital wave function
+        LPsiDatA = (fftw_complex *) coeffs_buffer[k];    // new coeffs first go to copy buffer, old ones must not be overwritten yet
+        SetArrayToDouble0((double *)LPsiDatA, 2*LevS->MaxG);  // zero buffer part
+      } else
+        LPsiDatA = NULL;  // otherwise processes won't enter second loop, though they're supposed to send coefficients!
+
+      m = -1; // to access U matrix element (0..Num-1)
+      for (j=0; j < Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT; j++) {  // go through all wave functions
+        OnePsiB = &Psi->AllPsiStatus[j];    // grab OnePsiB
+        if (OnePsiB->PsiType == type) {   // drop all but occupied ones
+          m++;  // increase m if it is occupied wave function
+          if (OnePsiB->my_color_comm_ST_Psi == P->Par.my_color_comm_ST_Psi) // local?
+             LOnePsiB = &Psi->LocalPsiStatus[OnePsiB->MyLocalNo];
+          else 
+             LOnePsiB = NULL;
+          if (LOnePsiB == NULL) {   // if it's not local ... receive it from respective process into TempPsi
+            RecvSource = OnePsiB->my_color_comm_ST_Psi;
+            MPI_Recv( LevS->LPsi->TempPsi, LevS->MaxG*ElementSize, MPI_DOUBLE, RecvSource, WannierTag2, P->Par.comm_ST_PsiT, &status );
+            LPsiDatB=LevS->LPsi->TempPsi;
+          } else {                  // .. otherwise send it to all other processes (Max_me... - 1)
+            for (p=0;p<P->Par.Max_me_comm_ST_PsiT;p++)
+              if (p != OnePsiB->my_color_comm_ST_Psi) 
+                MPI_Send( LevS->LPsi->LocalPsi[OnePsiB->MyLocalNo], LevS->MaxG*ElementSize, MPI_DOUBLE, p, WannierTag2, P->Par.comm_ST_PsiT);
+            LPsiDatB=LevS->LPsi->LocalPsi[OnePsiB->MyLocalNo];
+          } // LPsiDatB is now set to the coefficients of OnePsi either stored or MPI_Received
+
+          if (LPsiDatA != NULL) {
+            double tmp = gsl_matrix_get(U,l,m);
+            g=0;
+            if (LevS->GArray[0].GSq == 0.0) {
+              LPsiDatA[g].re += LPsiDatB[g].re * tmp;
+              LPsiDatA[g].im += LPsiDatB[g].im * tmp;
+              g++;
+            }
+            for (; g < LevS->MaxG; g++) {
+              LPsiDatA[g].re += LPsiDatB[g].re * tmp;
+              LPsiDatA[g].im += LPsiDatB[g].im * tmp;
+            }
+          }
+        }
+      }
+    }
+  }
+
+  //if(P->Call.out[StepLeaderOut]) fprintf(stderr,"(%i) STEP 6: Swapping buffer mem\n",P->Par.me);
+  // now, as all wave functions are updated, swap the buffer
+  l = -1;
+  for (k=0;k<Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT;k++) { // go through each local occupied wave function
+    if (Psi->AllPsiStatus[k].PsiType == type && Psi->AllPsiStatus[k].my_color_comm_ST_Psi == P->Par.my_color_comm_ST_Psi) {
+      l++;
+      //if(P->Call.out[StepLeaderOut]) fprintf(stderr,"(%i) (k:%i,l:%i) LocalNo = (%i,%i)\t AllPsiNo = (%i,%i)\n", P->Par.me, k,l,Psi->LocalPsiStatus[l].MyLocalNo, Psi->LocalPsiStatus[l].MyGlobalNo, Psi->AllPsiStatus[k].MyLocalNo, Psi->AllPsiStatus[k].MyGlobalNo);
+      LPsiDatA = (fftw_complex *)coeffs_buffer[l];
+      LPsiDatB = LevS->LPsi->LocalPsi[l];
+      for (g=0;g<LevS->MaxG;g++) {
+        LPsiDatB[g].re = LPsiDatA[g].re;
+        LPsiDatB[g].im = LPsiDatA[g].im;
+      }
+      // recalculating non-local form factors which are coefficient dependent!
+      CalculateNonLocalEnergyNoRT(P, Psi->LocalPsiStatus[l].MyLocalNo);
+    }
+  } 
+  // and free allocated buffer memory
+  Free(coeffs_buffer, "UnitaryTransformationOnWavefunctions: coeffs_buffer");
+}
+
+/** Changes Wannier Centres according to RunStruct#CommonWannier.
+ * \param *P Problem at hand.
+ * \param Num number of Psis
+ * \param **WannierCentre 2D array (NDIM, \a Num) with wannier centres
+ * \param *WannierSpread array with wannier spread per wave function
+ */
+void ChangeWannierCentres(struct Problem *P, int Num, double **WannierCentre, double *WannierSpread)
+{
+  struct RunStruct *R = &P->R;
+  struct Lattice *Lat = &P->Lat;
+  struct LatticeLevel *LevS = R->LevS;
+  int *marker, **group;
+  int partner[Num];
+  int i,j,l,k;
+  int totalflag, flag;
+  double q[NDIM], center[NDIM];
+  double Spread;
+  int *N = LevS->Plan0.plan->N;
+  
+  switch (R->CommonWannier) {
+   case 4:
+    debug(P,"Shifting each Wannier centers to cell center");
+    for (j=0;j<NDIM;j++)  // center point in [0,1]^3
+      center[j] = 0.5;
+    RMat33Vec3(q,Lat->RealBasis, center); // transform to real coordinates
+    for (i=0; i < Num; i++) {  // go through all occupied wave functions
+      for (j=0;j<NDIM;j++)  // put into Wannier centres
+        WannierCentre[i][j] = q[j]; 
+    }    
+    break;
+   case 3:
+    debug(P,"Shifting Wannier centers individually to nearest grid point");
+    for (i=0;i < Num; i++) {  // go through all wave functions
+      RMat33Vec3(q, Lat->ReciBasis, WannierCentre[i]);
+      for (j=0;j<NDIM;j++) {  // Recibasis is not true inverse but times 2.*PI
+        q[j] *= (double)N[j]/(2.*PI);
+        
+        //fprintf(stderr,"(%i) N[%i]: %i\t tmp %e\t floor %e\t ceil %e\n",P->Par.me, j, N[j], tmp, floor(tmp), ceil(tmp));
+        if (fabs((double)floor(q[j]) - q[j]) < fabs((double)ceil(q[j]) - q[j]))
+          q[j] = floor(q[j])/(double)N[j];
+        else
+          q[j] = ceil(q[j])/(double)N[j];
+      }
+      RMat33Vec3(WannierCentre[i], Lat->RealBasis, q);
+    }
+    break;
+   case 2:
+    debug(P,"Combining individual orbitals according to spread.");
+    //fprintf(stderr,"(%i) Finding multiple bindings and Reweighting Wannier centres\n",P->Par.me);
+    debug(P,"finding partners");
+    marker = (int*) Malloc(sizeof(int)*(Num+1),"ComputeMLWF: marker");
+    group = (int**) Malloc(sizeof(int *)*Num,"ComputeMLWF: group");
+    for (l=0;l<Num;l++) {
+      group[l] = (int*) Malloc(sizeof(int)*(Num+1),"ComputeMLWF: group[l]");  // each must group must have one more as end marker
+      for (k=0;k<=Num;k++)
+        group[l][k] = -1; // reset partner group
+    }
+    for (k=0;k<Num;k++)
+      partner[k] = 0;
+    debug(P,"mem allocated");
+    // go for each orbital through every other, check distance against the sum of both spreads
+    // if smaller add to group of this orbital
+    for (l=0;l<Num;l++) {
+      j=0;  // index for partner group
+      for (k=0;k<Num;k++) {  // check this against l
+        Spread = 0.;
+        for (i=0;i<NDIM;i++) {
+          //fprintf(stderr,"(%i) Spread += (%e - %e)^2 \n", P->Par.me, WannierCentre[l][i], WannierCentre[k][i]); 
+          Spread += (WannierCentre[l][i] - WannierCentre[k][i])*(WannierCentre[l][i] - WannierCentre[k][i]);
+        }
+        Spread = sqrt(Spread);  // distance in Spread
+        //fprintf(stderr,"(%i) %i to %i: distance %e, SpreadSum = %e + %e = %e \n", P->Par.me, l, k, Spread, WannierSpread[l], WannierSpread[k], WannierSpread[l]+WannierSpread[k]); 
+        if (Spread < 1.5*(WannierSpread[l]+WannierSpread[k])) {// if distance smaller than sum of spread
+          group[l][j++] = k;  // add k to group of l
+          partner[l]++;
+          //fprintf(stderr,"(%i) %i added as %i-th member to %i's group.\n", P->Par.me, k, j, l);
+        } 
+      }
+    }
+    
+    // consistency, for each orbital check if this orbital is also in the group of each referred orbital
+    debug(P,"checking consistency");
+    totalflag = 1;
+    for (l=0;l<Num;l++) // checking l's group
+      for (k=0;k<Num;k++) { // k is partner index
+        if (group[l][k] != -1) {  // if current index k is a partner
+          flag = 0;
+          for(j=0;j<Num;j++) {  // go through each entry in l partner's partner group if l exists
+            if ((group[ group[l][k] ][j] == l))
+              flag = 1;
+          }
+          //if (flag == 0) fprintf(stderr, "(%i) in %i's group %i is referred as a partner, but not the other way round!\n", P->Par.me, l, group[l][k]);
+          if (totalflag == 1) totalflag = flag;
+        }
+      }
+    // for each orbital group (marker group) weight each center to a total and put this into the local WannierCentres
+    debug(P,"weight and calculate new centers for partner groups");
+    for (l=0;l<=Num;l++)
+      marker[l] = 1;
+    if (totalflag) {
+      for (l=0;l<Num;l++) { // go through each orbital
+        if (marker[l] != 0) { // if it hasn't been reweighted
+          marker[l] = 0;
+          for (i=0;i<NDIM;i++) 
+            q[i] = 0.;
+          j = 0;
+          while (group[l][j] != -1) {
+            marker[group[l][j]] = 0;
+            for (i=0;i<NDIM;i++) {
+              //fprintf(stderr,"(%i) Adding to %i's group, %i entry of %i: %e\n", P->Par.me, l, i, group[l][j], WannierCentre[ group[l][j] ][i]);
+              q[i] += WannierCentre[ group[l][j] ][i];
+            } 
+            j++;
+          }
+          //fprintf(stderr,"(%i) %i's group: (%e,%e,%e)/%i = (%e,%e,%e)\n", P->Par.me, l, q[0], q[1], q[2], j, q[0]/(double)j, q[1]/(double)j, q[2]/(double)j);
+          for (i=0;i<NDIM;i++) {// weight by number of elements in partner group
+            q[i] /= (double)(j);
+          }
+  
+          // put WannierCentre into own and all partners'      
+          for (i=0;i<NDIM;i++)
+            WannierCentre[l][i] = q[i];
+          j = 0;  
+          while (group[l][j] != -1) {
+            for (i=0;i<NDIM;i++)
+              WannierCentre[group[l][j]][i] = q[i];
+            j++;
+          }
+        }
+      }
+    }
+    if (P->Call.out[StepLeaderOut]) {
+      fprintf(stderr,"Summary:\n");
+      fprintf(stderr,"========\n");
+      for (i=0;i<Num;i++)
+        fprintf(stderr,"%i belongs to a %i-ple binding.\n",i,partner[i]);
+    } 
+    debug(P,"done");
+  
+    Free(marker, "ChangeWannierCentres: marker");
+    for (l=0;l<Num;l++)
+      Free(group[l], "ChangeWannierCentres: group[l]");
+    Free(group, "ChangeWannierCentres: group");
+    break;
+   case 1:
+    debug(P,"Individual orbitals are changed to center of all.");
+    for (i=0;i<NDIM;i++)  // zero center of weight
+      q[i] = 0.;
+    for (k=0;k<Num;k++)
+      for (i=0;i<NDIM;i++) {  // sum up all orbitals each component
+        q[i] += WannierCentre[k][i];
+      }
+    for (i=0;i<NDIM;i++)  // divide by number
+      q[i] /= Num;
+    for (k=0;k<Num;k++)
+      for (i=0;i<NDIM;i++) {  // put into this function's array
+        WannierCentre[k][i] = q[i];
+      }
+    break;
+   case 0:
+   default:
+   break;
+  }
+}
+
+/** From the entries of the variance matrices the spread is calculated.
+ * WannierCentres are evaluated according to Resta operator: \f$\langle X \rangle = \frac{L}{2\pi} \sum_j {\cal I} \ln{\langle \Psi_j | \exp{(i \frac{2\pi}{L} X)} | \Psi_j \rangle}\f$
+ * WannierSpread is: \f$ \sum_j \langle \Psi_j | r^2 | \Psi_j \rangle - \langle \Psi_j | r | psi_j \rangle^2\f$
+ * \param *P Problem at hand
+ * \param *A variance matrices
+ * \param old_spread first term of wannier spread
+ * \param spread second term of wannier spread
+ * \param **WannierCentre 2D array (NDIM, \a Num) with wannier centres
+ * \param *WannierSpread array with wannier spread per wave function
+ */
+void ComputeWannierCentresfromVarianceMatrices(struct Problem *P, gsl_matrix **A, double *spread, double *old_spread, double **WannierCentre, double *WannierSpread)
+{
+  struct Lattice *Lat = &P->Lat;
+  struct Psis *Psi = &Lat->Psi;
+  struct OnePsiElement *OnePsiA;
+  int i,j,k,l;
+  double tmp, q[NDIM];
+  
+  *old_spread = 0;
+  *spread = 0;
+
+  // the spread for x,y,z resides in the respective diagonal element of A_.. for each orbital
+  i=-1;
+  for (l=0; l < Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT; l++) {  // go through all wave functions
+    OnePsiA = &Psi->AllPsiStatus[l];    // grab OnePsiA
+    if (OnePsiA->PsiType == type) {   // drop all but occupied ones
+      i++;  // increase l if it is occupied wave function
+      //fprintf(stderr,"(%i) Wannier for %i\n", P->Par.me, i);
+      
+      // calculate Wannier Centre
+      for (j=0;j<NDIM;j++) {
+        q[j] = 1./(2.*PI) * GSL_IMAG( gsl_complex_log( gsl_complex_rect(gsl_matrix_get(A[j*2],i,i),gsl_matrix_get(A[j*2+1],i,i))));
+        if (q[j] < 0) // change wrap around of above operator to smooth 0...Lat->RealBasisSQ
+          q[j] += 1.;
+      }
+      RMat33Vec3(WannierCentre[i], Lat->RealBasis, q);
+      
+      // store orbital spread and centre in file
+      tmp = - pow(gsl_matrix_get(A[0],i,i),2) - pow(gsl_matrix_get(A[1],i,i),2)
+            - pow(gsl_matrix_get(A[2],i,i),2) - pow(gsl_matrix_get(A[3],i,i),2)
+            - pow(gsl_matrix_get(A[4],i,i),2) - pow(gsl_matrix_get(A[5],i,i),2);          
+      WannierSpread[i] = gsl_matrix_get(A[max_operators],i,i) + tmp; 
+      //fprintf(stderr,"(%i) WannierSpread[%i] = %e\n", P->Par.me, i, WannierSpread[i]);
+      //if (P->Par.me == 0) fprintf(F->SpreadFile,"Orbital %d:\t Wannier center (x,y,z)=(%lg,%lg,%lg)\t Spread sigma^2 = %lg - %lg = %lg\n",
+        //Psi->AllPsiStatus[i].MyGlobalNo, WannierCentre[i][0], WannierCentre[i][1], WannierCentre[i][2], gsl_matrix_get(A[max_operators],i,i), -tmp, WannierSpread[i]); 
+      //if (P->Par.me == 0) fprintf(F->SpreadFile,"%e\t%e\t%e\n",
+        //WannierCentre[i][0], WannierCentre[i][1], WannierCentre[i][2]);
+      
+      // gather all spreads
+      *old_spread += gsl_matrix_get(A[max_operators],i,i); // tr(U^H B U)
+      for (k=0;k<max_operators;k++)
+        *spread += pow(gsl_matrix_get(A[k],i,i),2);
+    }
+  }
+}
+
+/** Prints gsl_matrix nicely to screen.
+ * \param *P Problem at hand
+ * \param *U gsl matrix
+ * \param Num number of rows/columns
+ * \param *msg name of matrix, prepended before entries
+ */
+void PrintGSLMatrix(struct Problem *P, gsl_matrix *U, int Num, const char *msg)
+{
+  int k,l;
+  fprintf(stderr,"(%i) %s = \n",P->Par.me, msg);
+  for (k=0;k<Num;k++) {    
+    for (l=0;l<Num;l++)
+      fprintf(stderr,"%e\t",gsl_matrix_get(U,l,k));
+    fprintf(stderr,"\n");
+  }
+}
+
+/** Allocates memory for the  DiagonalizationData structure
+ * \param *P Problem at hand
+ * \param DiagData pointer to structure
+ * \param Num number of rows and columns in matrix
+ * \param NumMatrices number of matrices to be simultaneously diagonalized
+ * \param extra number of extra matrices to be passively also diagonalized
+ */
+void InitDiagonalization(struct Problem *P, struct DiagonalizationData *DiagData, int Num, int NumMatrices, int extra)
+{
+  int i;
+  
+  // store integer values
+  //if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 1\n",P->Par.me);
+  DiagData->Num = Num;
+  DiagData->AllocNum = ceil((double)Num / 2. ) *2;
+  DiagData->NumMatrices = NumMatrices;
+  DiagData->extra = extra;
+  
+  // determine communicator and our rank and its size
+  DiagData->comm = DetermineParallelGroupbyGCD(P,DiagData->AllocNum);
+  MPI_Comm_size (*(DiagData->comm), &(DiagData->ProcNum));
+  MPI_Comm_rank (*(DiagData->comm), &(DiagData->ProcRank));
+  
+  // allocate memory
+  DiagData->U = gsl_matrix_calloc(DiagData->AllocNum,DiagData->AllocNum);
+  gsl_matrix_set_identity(DiagData->U);
+  
+  DiagData->A = (gsl_matrix **) Malloc((DiagData->NumMatrices+DiagData->extra) * sizeof(gsl_matrix *), "InitDiagonalization: *A"); 
+  for (i=0;i<(DiagData->NumMatrices+DiagData->extra);i++) {
+    DiagData->A[i] = gsl_matrix_calloc(DiagData->AllocNum,DiagData->AllocNum);
+    gsl_matrix_set_zero(DiagData->A[i]);
+  }
+
+  // init merry-go-round array for diagonilzation
+  DiagData->top = (int *) Malloc(sizeof(int)*DiagData->AllocNum/2, "InitDiagonalization: top");
+  DiagData->bot = (int *) Malloc(sizeof(int)*DiagData->AllocNum/2, "InitDiagonalization: bot");
+  for (i=0;i<DiagData->AllocNum/2;i++) {
+    DiagData->top[i] = 2*i;
+    DiagData->bot[i] = 2*i+1;      
+  }
+/*    // print starting values of index generation tables top and bot
+      fprintf(stderr,"top\t");
+      for (k=0;k<AllocNum/2;k++)
+        fprintf(stderr,"%i\t", top[k]);
+      fprintf(stderr,"\n");
+      fprintf(stderr,"bot\t");
+      for (k=0;k<AllocNum/2;k++)
+        fprintf(stderr,"%i\t", bot[k]);
+      fprintf(stderr,"\n");*/
+}
+
+/** Frees allocated memory for the DiagonalizationData structure.
+ * \param DiagData pointer to structure
+ */
+void FreeDiagonalization(struct DiagonalizationData *DiagData)
+{
+  int i;
+  
+  Free(DiagData->top, "FreeDiagonalization: DiagData->top");
+  Free(DiagData->bot, "FreeDiagonalization: DiagData->bot");
+  gsl_matrix_free(DiagData->U);
+  for (i=0;i<(DiagData->NumMatrices+DiagData->extra);i++)
+    gsl_matrix_free(DiagData->A[i]);   
+  Free(DiagData->A, "FreeDiagonalization: DiagData->A");
+}
+
+/** Orthogonalizing PsiType#Occupied wave functions for MD.
+ * Orthogonalizes wave functions by finding a unitary transformation such that the density remains unchanged.
+ * To this end, the overlap matrix \f$\langle \Psi_i | \Psi_j \rangle\f$ is created and diagonalised by Jacobi
+ * transformation (product of rotation matrices). The found transformation matrix is applied to all Psis.
+ * \param *P Problem at hand
+ * \note [Payne] states that GramSchmidt is not well-suited. However, this Jacobi diagonalisation is not well
+ * suited for our CG minimisation either. If one wave functions is changed in course of the minimsation
+ * procedure, in a Gram-Schmidt-Orthogonalisation only this wave function is changed (although it remains under
+ * debate whether subsequent Psis are still orthogonal to this changed wave function!), in a Jacobi-Orthogonali-
+ * stion however at least two if not all wave functions are changed. Thus inhibits our fast way of updating the
+ * density after a minimisation step -- UpdateDensityCalculation(). Thus, this routine can only be used for a
+ * final orthogonalisation of all Psis, after the CG minimisation.
+ */
+void OrthogonalizePsis(struct Problem *P)
+{
+  struct Lattice *Lat = &P->Lat;
+  struct Psis *Psi = &Lat->Psi;
+  struct LatticeLevel *LevS = P->R.LevS;
+  int Num = Psi->NoOfPsis;
+  int i,j,l;
+  struct DiagonalizationData DiagData;
+  double PsiSP;
+
+  InitDiagonalization(P, &DiagData, Num, 1, 0);
+    
+  // Calculate Overlap matrix
+  for (l=Psi->TypeStartIndex[Occupied]; l<Psi->TypeStartIndex[UnOccupied]; l++)
+    CalculateOverlap(P, l, Occupied);  
+  for (i=0;i<Num;i++) // fill gsl matrix with overlap values
+    for (j=0;j<Num;j++)
+      gsl_matrix_set(DiagData.A[0],i,j,Psi->Overlap[i][j]);
+  //if (P->Call.out[ReadOut]) PrintGSLMatrix(P,DiagData.A[0],Num,"<Psi_i|Psi_J> (before)");
+  
+  //if (P->Call.out[ReadOut]) PrintGSLMatrix(P,DiagData.U,Num,"Transformation (before)");
+
+  // diagonalize overlap matrix
+  Diagonalize(P, &DiagData);
+
+  //if (P->Call.out[ReadOut]) PrintGSLMatrix(P,DiagData.U,Num,"Transformation (after)");
+
+  // apply found unitary transformation to wave functions
+  UnitaryTransformationOnWavefunctions(P, DiagData.U, DiagData.AllocNum);
+
+  // update GramSch stati
+  for (i=Psi->TypeStartIndex[Occupied];i<Psi->TypeStartIndex[UnOccupied];i++) {
+    GramSchNormalize(P,LevS,LevS->LPsi->LocalPsi[i], 0.);   // calculates square product if 0. is given...
+    PsiSP = GramSchGetNorm2(P,LevS,LevS->LPsi->LocalPsi[i]);
+    //if (P->Par.me_comm_ST_Psi == 0) fprintf(stderr,"(%i) PsiSP[%i] = %lg\n", P->Par.me, i, PsiSP);
+    Psi->LocalPsiStatus[i].PsiGramSchStatus = (int)IsOrthonormal;
+  }
+  UpdateGramSchAllPsiStatus(P,Psi);
+/*
+  for (l=Psi->TypeStartIndex[Occupied]; l<Psi->TypeStartIndex[UnOccupied]; l++)
+    CalculateOverlap(P, l, Occupied);  
+  for (i=0;i<Num;i++) // fill gsl matrix with overlap values
+    for (j=0;j<Num;j++)
+      gsl_matrix_set(DiagData.A[0],i,j,Psi->Overlap[i][j]);
+  if (P->Call.out[ReadOut]) PrintGSLMatrix(P,DiagData.A[0],Num,"<Psi_i|Psi_J> (after)");
+  */
+  // free memory
+  FreeDiagonalization(&DiagData);
+}
+
+/** Orthogonalizing PsiType#Occupied wave functions and their time derivatives for MD.
+ * Ensures that two orthonormality condition are met for Psis: 
+ * \f$\langle \Psi_i | \Psi_j \rangle = \delta_{ij}\f$
+ * \f$\langle \dot{\Psi_i} | \dot{\Psi_j} \rangle = \delta_{ij}\f$
+ * \param *P Problem at hand
+ * \note [Payne] states that GramSchmidt is not well-suited, and this stronger
+ *       condition is needed for numerical stability
+ * \todo create and fill 1stoverlap with finite difference between Psi, OldPsi with R->Deltat
+ */
+void StrongOrthogonalizePsis(struct Problem *P)
+{
+  struct Lattice *Lat = &P->Lat;
+  struct Psis *Psi = &Lat->Psi;
+  int Num = Psi->NoOfPsis;
+  int i,j,l;
+  struct DiagonalizationData DiagData;
+
+  InitDiagonalization(P, &DiagData, Num, 2, 0);
+    
+  // Calculate Overlap matrix
+  for (l=Psi->TypeStartIndex[Occupied]; l<Psi->TypeStartIndex[UnOccupied]; l++) {
+    CalculateOverlap(P, l, Occupied);  
+    //Calculate1stOverlap(P, l, Occupied);
+  }  
+  for (i=0;i<Num;i++) // fill gsl matrix with overlap values
+    for (j=0;j<Num;j++) {
+      gsl_matrix_set(DiagData.A[0],i,j,Psi->Overlap[i][j]);
+      //gsl_matrix_set(DiagData.A[1],i,j,Psi->1stOverlap[i][j]);
+    }
+      
+  // diagonalize overlap matrix
+  Diagonalize(P, &DiagData);
+  
+  // apply found unitary transformation to wave functions
+  UnitaryTransformationOnWavefunctions(P, DiagData.U, DiagData.AllocNum);
+  
+  // free memory
+  FreeDiagonalization(&DiagData);
+}
+
+/** Uses either serial or parallel diagonalization.
+ * \param *P Problem at hand
+ * \param *DiagData pointer to structure DiagonalizationData containing necessary information for diagonalization
+ * \sa ParallelDiagonalization(), SerialDiagonalization()
+ */
+void Diagonalize(struct Problem *P, struct DiagonalizationData *DiagData)
+{
+  if (DiagData->Num != 1) { // one- or multi-process case?
+    if (((DiagData->AllocNum % 2) == 0) && (DiagData->ProcNum != 1) && ((DiagData->AllocNum / 2) % DiagData->ProcNum == 0)) {
+      /*
+      debug(P,"Testing with silly matrix");
+      ParallelDiagonalization(P, test, Utest, 1, 0, 4, Num, comm, ProcRank, ProcNum, top, bot);
+      if(P->Call.out[ReadOut]) // && P->Par.me == 0) 
+        PrintGSLMatrix(P, test[0], 4, "test[0] (diagonalized)");
+      if(P->Call.out[ReadOut]) // && P->Par.me == 0) 
+        PrintGSLMatrix(P, Utest, 4, "Utest (final)");
+        */  
+      debug(P,"ParallelDiagonalization");
+      ParallelDiagonalization(P, DiagData);
+    } else {/*
+      debug(P,"Testing with silly matrix");
+      SerialDiagonalization(P, test, Utest, 1, 0, 4, Num, top, bot);
+      if(P->Call.out[ReadOut]) // && P->Par.me == 0) 
+        PrintGSLMatrix(P, test[0], 4, "test[0] (diagonalized)");
+      if(P->Call.out[ReadOut]) // && P->Par.me == 0) 
+        PrintGSLMatrix(P, Utest, 4, "Utest (final)");
+         */ 
+      debug(P,"SerialDiagonalization");
+      SerialDiagonalization(P, DiagData);
+    }  
+    
+    //if(P->Call.out[ReadOut]) // && P->Par.me == 0) 
+      //PrintGSLMatrix(P, DiagData->U, DiagData->AllocNum, "U");
+  }
 }
 
